/*
	Private libsharedmime header

	This is all the private definitions local to my implementation of
	libsharedmime. Some of which is taken from LGI
	(http://www.memecode.com/lgi.php)
	
	Author: Matthew Allen <fret@memecode.com>
	Date: 5/12/2003
*/

#ifndef _MIME_TYPES_PRIV_H_
#define _MIME_TYPES_PRIV_H_

// Global includes
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>

// Defines
#define CountOf(c)		(sizeof(c)/sizeof(c[0]))
#define stricmp			strcasecmp
#define strnicmp		strncasecmp
#ifdef WIN32
#define DIR_CHAR		'\\'
#define DIR_STR			"\\"
#else
#define DIR_CHAR		'/'
#define DIR_STR			"/"
#endif
#define DeleteObj(o)	if (o) { delete o; o = 0; }
#define DeleteArray(o)	if (o) { delete [] o; o = 0; }

// Local includes
#include "array.h"

// Types
typedef unsigned char	uchar;
typedef unsigned short	uint16;
typedef unsigned int	uint32;

// Functions
bool MakePath(char *Buf, char *Path, char *Seg);
int Lex(Array<char*> &Tokens, char *Str, char *Delim);
void TrimDir(char *Path);
char *ReadTextFile(char *File);
char *NewStr(char *Str, int Len = -1);
bool MatchStr(char *Template, char *Str);

#endif