/*
	"MIME LIST"

	A simple test application to list the mime types of the files in the current
	directory using the libsharedmime shared object.
	
	Author: Matthew Allen <fret@memecode.com>
	Date: 5/12/2003
*/


#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>

#include "../mime-types.h"
#define stricmp strcasecmp

char File[] = "/usr/bin/keditfiletype";

int main(int Args, char **Arg)
{
	printf("MLS v0.01\n\n");

	#if 0

	const char *Mt = mimetypes_get_file_type(File, MIMETYPES_CHECK_ALL);
	printf("Mimetype of '%s' is '%s'\n", File, Mt);
	
	#else
	
	char *Format = "%-50.50s%s\n"; // keeps the columns aligned
	printf(Format, "File", "Mime-Type");
	printf(Format, "----", "---------");

	mimetypes_init();
	char Cur[256];
	DIR *Dir = opendir(getcwd(Cur, sizeof(Cur)));
	if (Dir)
	{
		dirent *De;
		while (De = readdir(Dir))
		{
			if (stricmp(De->d_name, ".") != 0 &&
				stricmp(De->d_name, "..") != 0)
			{
				char Path[256];
				sprintf(Path, "%s/%s", Cur, De->d_name);
				const char *Mt = 0;
				switch (De->d_type)
				{
					case DT_DIR:
					{
						Mt = "<dir>";
						break;
					}
					case DT_LNK:
					case DT_REG:
					{
						Mt = mimetypes_get_file_type(Path, MIMETYPES_CHECK_ALL);
						break;
					}
				}
				printf(Format, De->d_name, Mt);
			}
		}
	}
	
	#endif
	
	printf("\n");
	return 0;
}
